package it.unicam.cs.asdl1819.mylist;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;

/**
 * Lista concatenata doppia che non accetta valori null, ma permette elementi
 * duplicati.
 * 
 * @author luca
 *
 * @param <E> il tipo degli elementi della lista
 */
public class MyList<E> implements List<E> {

    private int size;

    private Nodo testa;

    private Nodo coda;

    /**
     * Crea una lista vuota.
     */
    public MyList() {
        this.size = 0;
        this.testa = null;
        this.coda = null;
    }

    /**
     * Crea un lista con un solo elemento.
     * 
     * @param el
     *               l'elemento della lista
     */
    public MyList(E el) {
        this.size = 1;
        this.testa = new Nodo(el);
        this.coda = this.testa;

    }

    private class Nodo {
        private E el;

        private Nodo next;

        private Nodo previous;

        /*
         * Crea un nodo "singolo" equivalente a una lista con un solo elemento.
         */
        Nodo(E el) {
            this.el = el;
            this.next = null;
            this.previous = null;
        }
    }

    @Override
    public int size() {
        return this.size;
    }

    @Override
    public boolean isEmpty() {
        return this.size == 0;
    }

    @Override
    public boolean contains(Object o) {
        if (o == null)
            throw new NullPointerException("Oggetto da cercare nullo!");
        // Ricerca lineare a partire dalla testa della lista
        Nodo iPointer = this.testa;
        boolean trovato = false;
        while (!trovato && iPointer != null) {
            if (o.equals(iPointer.el))
                trovato = true;
            else
                iPointer = iPointer.next;
        }
        if (trovato)
            return true;
        else
            return false; // equivalente a return trovato;
    }

    @Override
    public Iterator<E> iterator() {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public Object[] toArray() {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public <T> T[] toArray(T[] a) {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public boolean add(E e) {
        // TODO Auto-generated method stub
        return false;
    }

    @Override
    public boolean remove(Object o) {
        // TODO Auto-generated method stub
        return false;
    }

    @Override
    public boolean containsAll(Collection<?> c) {
        // TODO Auto-generated method stub
        return false;
    }

    @Override
    public boolean addAll(Collection<? extends E> c) {
        // TODO Auto-generated method stub
        return false;
    }

    @Override
    public boolean addAll(int index, Collection<? extends E> c) {
        // TODO Auto-generated method stub
        return false;
    }

    @Override
    public boolean removeAll(Collection<?> c) {
        // TODO Auto-generated method stub
        return false;
    }

    @Override
    public boolean retainAll(Collection<?> c) {
        // TODO Auto-generated method stub
        return false;
    }

    @Override
    public void clear() {
        // TODO Auto-generated method stub

    }

    @Override
    public E get(int index) {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public E set(int index, E element) {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void add(int index, E element) {
        // TODO Auto-generated method stub

    }

    @Override
    public E remove(int index) {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public int indexOf(Object o) {
        // TODO Auto-generated method stub
        return 0;
    }

    @Override
    public int lastIndexOf(Object o) {
        // TODO Auto-generated method stub
        return 0;
    }

    @Override
    public ListIterator<E> listIterator() {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public ListIterator<E> listIterator(int index) {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public List<E> subList(int fromIndex, int toIndex) {
        // TODO Auto-generated method stub
        return null;
    }

}
